# @nuxtjs/content

[![npm version][npm-version-src]][npm-version-href]
[![npm downloads][npm-downloads-src]][npm-downloads-href]
[![Github Actions CI][github-actions-ci-src]][github-actions-ci-href]
[![Codecov][codecov-src]][codecov-href]
[![License][license-src]][license-href]

> @nuxtjs/content lets you write in a content/ directory, acting as flat file headless CMS

## Features

- Blazing fast hot reload when writing your content
- Vue components in Markdown
- Full-text search
- Support static site generation with `nuxt generate`
- Powerful QueryBuilder API (MongoDB like)
- Syntax highlighting to code blocks in markdown files using PrismJS.
- Table of contents generation
- Handles Markdown, CSV, YAML, JSON(5)
- Extend with hooks

[📖 Read the documentation](https://content.nuxtjs.org)

## Development

1. Clone this repository
2. Install dependencies using `yarn install` or `npm install`
3. Start development server using `yarn dev` or `npm run dev`

## License

[MIT License](./LICENSE)

Copyright (c) NuxtJS Company

<!-- Badges -->
[npm-version-src]: https://img.shields.io/npm/v/@nuxtjs/content/latest.svg
[npm-version-href]: https://npmjs.com/package/@nuxtjs/content

[npm-downloads-src]: https://img.shields.io/npm/dt/@nuxtjs/content.svg
[npm-downloads-href]: https://npmjs.com/package/@nuxtjs/content

[github-actions-ci-src]: https://github.com/nuxt-company/content-module/workflows/ci/badge.svg
[github-actions-ci-href]: https://github.com/nuxt-company/content-module/actions?query=workflow%3Aci

[codecov-src]: https://img.shields.io/codecov/c/github/nuxt-company/content-module.svg
[codecov-href]: https://codecov.io/gh/nuxt-company/content-module

[license-src]: https://img.shields.io/npm/l/@nuxtjs/content.svg
[license-href]: https://npmjs.com/package/@nuxtjs/content
